package com.pokkt.demo

import android.app.Activity
import android.content.Context
import android.view.ViewGroup
import com.pokkt.PokktAds
import com.pokkt.igaservice.IGAServiceProvider
import com.pokkt.sdk.analytics.AnalyticsDetails
import com.pokkt.sdk.banners.PokktBannerView
import com.pokkt.sdk.models.InAppPurchaseDetail
import com.pokkt.sdk.models.PokktAdViewConfig
import com.pokkt.sdk.models.PokktUserDetails

fun setPokktConfig(applicationId: String, securityKey: String, activity: Activity) {
    PokktAds.setPokktConfig(applicationId, securityKey, activity)
}

fun setThirdPartyUserId(userId: String) {
    PokktAds.setThirdPartyUserId(userId)
}

fun setAdPlayerViewConfig(adPlayerViewConfig: PokktAdViewConfig) {
    PokktAds.setAdPlayerViewConfig(adPlayerViewConfig)
}

fun setUserDetails(userDetails: PokktUserDetails) {
    PokktAds.setUserDetails(userDetails)
}

fun setCallbackExtraParams(extraParams: Map<String, String>) {
    PokktAds.setCallbackExtraParams(extraParams)
}

fun setDataAccessConsent(consentInfo: PokktAds.ConsentInfo?) {
    if (consentInfo != null) {
        PokktAds.setDataAccessConsent(consentInfo)
    }
}

fun getDataAccessConsent(): PokktAds.ConsentInfo {
    return PokktAds.getDataAccessConsent()
}

fun getSDKVersion(): String {
    return PokktAds.getSDKVersion()
}

fun setDelegate(delegate: PokktAds.VideoAd.VideoAdDelegate) {
    PokktAds.VideoAd.setDelegate(delegate)
}

fun cacheRewardedVideo(screenName: String) {
    PokktAds.VideoAd.cacheRewarded(screenName)
}

fun cacheRewardedVideoWithDelegate(screenName: String, adDelegate: PokktAds.VideoAd.VideoAdDelegate?) {
    PokktAds.VideoAd.cacheRewardedWithDelegate(screenName, adDelegate)
}

fun showRewardedVideo(screenName: String) {
    PokktAds.VideoAd.showRewarded(screenName)
}

fun showRewardedVideoWithDelegate(screenName: String, adDelegate: PokktAds.VideoAd.VideoAdDelegate?) {
    PokktAds.VideoAd.showRewardedWithDelegate(screenName, adDelegate)
}

fun cacheNonRewardedVideo(screenName: String) {
    PokktAds.VideoAd.cacheNonRewarded(screenName)
}

fun cacheNonRewardedVideoWithDelegate(screenName: String, adDelegate: PokktAds.VideoAd.VideoAdDelegate?) {
    PokktAds.VideoAd.cacheNonRewardedWithDelegate(screenName, adDelegate)
}

fun showNonRewardedVideo(screenName: String) {
    PokktAds.VideoAd.showNonRewarded(screenName)
}

fun showNonRewardedVideoWithDelegate(screenName: String, adDelegate: PokktAds.VideoAd.VideoAdDelegate?) {
    PokktAds.VideoAd.showNonRewardedWithDelegate(screenName, adDelegate)
}

fun isVideoAdCached(screenName: String, isRewarded: Boolean): Boolean {
    return PokktAds.VideoAd.isAdCached(screenName,isRewarded)
}

fun setDelegate(delegate: PokktAds.Interstitial.InterstitialDelegate) {
    PokktAds.Interstitial.setDelegate(delegate)
}

fun cacheRewardedInterstitial(screenName: String) {
    PokktAds.Interstitial.cacheRewarded(screenName)
}

fun cacheRewardedInterstitialWithDelegate(screenName: String, adDelegate: PokktAds.Interstitial.InterstitialDelegate?) {
    PokktAds.Interstitial.cacheRewardedWithDelegate(screenName, adDelegate)
}

fun showRewardedInterstitial(screenName: String) {
    PokktAds.Interstitial.showRewarded(screenName)
}

fun showRewardedInterstitialWithDelegate(screenName: String, adDelegate: PokktAds.Interstitial.InterstitialDelegate?) {
    PokktAds.Interstitial.showRewardedWithDelegate(screenName, adDelegate)
}

fun cacheNonRewardedInterstitial(screenName: String) {
    PokktAds.Interstitial.cacheNonRewarded(screenName)
}

fun cacheNonRewardedInterstitialWithDelegate(screenName: String, adDelegate: PokktAds.Interstitial.InterstitialDelegate?) {
    PokktAds.Interstitial.cacheNonRewardedWithDelegate(screenName, adDelegate)
}

fun showNonRewardedInterstitial(screenName: String) {
    PokktAds.Interstitial.showNonRewarded(screenName)
}

fun showNonRewardedInterstitialWithDelegate(screenName: String, adDelegate: PokktAds.Interstitial.InterstitialDelegate?) {
    PokktAds.Interstitial.showNonRewardedWithDelegate(screenName, adDelegate)
}

fun isInterstitialAdCached(screenName: String, isRewarded: Boolean): Boolean {
    return PokktAds.Interstitial.isAdCached(screenName,isRewarded)
}

fun loadAdInContainer(activity: Activity, container: ViewGroup, screenName: String, position: Int, delegate: PokktAds.OSAds.OSAdsDelegate) {
    PokktAds.OSAds.loadAdInContainer(activity, container, screenName, position, delegate)
}

fun destroyAdInContainer(screenName: String) {
    PokktAds.OSAds.destroyAdInContainer(screenName)
}

fun initAgent(activity: Activity, screenName: String) {
    PokktAds.OSAds.initAgent(activity, screenName)
}

fun setDelegate(delegate: PokktAds.Banner.BannerAdDelegate) {
    PokktAds.Banner.setDelegate(delegate)
}

fun loadBanner(screenName: String, pokktBannerView: PokktBannerView) {
    PokktAds.Banner.loadBanner(screenName, pokktBannerView)
}

fun destroy(container: PokktBannerView) {
    PokktAds.Banner.destroy(container)
}

fun onRequestPermissionsResult(requestCode: Int, permissions: Array<String>, grantResults: IntArray, container: PokktBannerView) {
    PokktAds.Banner.onRequestPermissionsResult(requestCode, permissions, grantResults, container)
}

fun setIGAServiceProvider(igaServiceProvider: IGAServiceProvider) {
    PokktAds.InGameAd.setIGAServiceProvider(igaServiceProvider)
}

fun setDelegate(delegate: PokktAds.InGameAd.IGADelegate) {
    PokktAds.InGameAd.setDelegate(delegate)
}

fun fetchAssets(screenName: String) {
    PokktAds.InGameAd.fetchAssets(screenName)
}

fun trackFUClick(clickType: Int, assetType: String) {
    PokktAds.InGameAd.trackFUClick(clickType, assetType)
}

fun updateIGAData(data: String) {
    PokktAds.InGameAd.updateIGAData(data)
}

fun setAnalyticsDetails(analyticsDetails: AnalyticsDetails) {
    PokktAds.Analytics.setAnalyticsDetails(analyticsDetails)
}

fun trackIAP(detail: InAppPurchaseDetail) {
    PokktAds.Analytics.trackIAP(detail)
}

fun isEnabled(): Boolean {
    return PokktAds.Debugging.isEnabled()
}

fun shouldDebug(context: Context, value: Boolean) {
    PokktAds.Debugging.shouldDebug(context, value)
}

fun exportLog(context: Activity) {
    PokktAds.Debugging.exportLog(context)
}

fun exportLogToCloud(context: Context) {
    PokktAds.Debugging.exportLogToCloud(context)
}

fun showToast(context: Context, message: String) {
    PokktAds.Debugging.showToast(context, message)
}

fun showLog(message: String) {
    PokktAds.Debugging.showLog(message)
}