package com.pokkt.demo.fragments;

import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Toast;

import com.pokkt.PokktAds;
import com.pokkt.ad.demo.BuildConfig;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.PokktKotlinPluginKt;
import com.pokkt.demo.utility.SharedPrefsUtil;

import static com.pokkt.demo.utility.SharedPrefsUtilConstant.*;

import com.pokkt.demo.utility.Storage;
import com.pokkt.sdk.debugging.Logger;
import com.pokkt.sdk.models.PokktAdViewConfig;
import com.pokkt.sdk.utils.PokktConstants;

import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;


public class PokktExtraParamsFragment extends BaseFragment {

    // ui
    private Button btnAddExtraParams, btnRemoveExtraParams, btnSend, btnTestPlay,btnCPIRule;
    private RadioGroup radGrpVastProtocol;
    private EditText editCPIRule;
    private LinearLayout lnrLayoutExtraParamsContainer;

    private LayoutInflater inflater;

    PokktAdViewConfig config = new PokktAdViewConfig();

    public PokktExtraParamsFragment() {
        // Required empty public constructor
    }


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // getArguments here
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_pokkt_extra_params, container, false);
        btnAddExtraParams = (Button) rootView.findViewById(R.id.btnAddExtraParams);
        btnRemoveExtraParams = (Button) rootView.findViewById(R.id.btnRemoveExtraParams);
        btnSend = (Button) rootView.findViewById(R.id.btnSend);
        btnTestPlay = (Button) rootView.findViewById(R.id.btnTestPlay);
        radGrpVastProtocol = (RadioGroup) rootView.findViewById(R.id.rad_grp_vast_protocol);
        btnCPIRule = rootView.findViewById(R.id.btnCPIRule);
        editCPIRule = rootView.findViewById(R.id.editCpiRule);
        editCPIRule.setText(PokktConstants.CPIRULE);
        lnrLayoutExtraParamsContainer = (LinearLayout) rootView.findViewById(R.id.lnrLayoutExtraParamsContainer);
        this.inflater = inflater;
        btnAddExtraParams.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                addRow();
            }
        });
        btnRemoveExtraParams.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                resetData();
            }
        });
        btnSend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                saveData();
                Map<String, ?> map_extra_params1 = SharedPrefsUtil.getMapFromPref(getActivity().getApplicationContext(), PREF_EXTRA_PARAMS);

                Map<String,String> map_extra_params = new HashMap<>();
                if (map_extra_params1.size() > 0) {
                    for (Map.Entry<String, ?> pair : map_extra_params1.entrySet()) {
                        map_extra_params.put(pair.getKey(), (String) pair.getValue());
                    }
                }

                if(map_extra_params.size() > 0){
                    if(Storage.isKotlin) {
                        PokktKotlinPluginKt.setCallbackExtraParams(map_extra_params);
                    } else {
                        PokktAds.setCallbackExtraParams(map_extra_params);
                    }
                }
                else{
                    Toast.makeText(getActivity().getApplicationContext(), "Add extra params to be sent to PokktSDK", Toast.LENGTH_SHORT).show();
                }
            }
        });

        btnTestPlay.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(BuildConfig.DEBUG && Logger.getShouldLog()) {
                    new PokktAdViewConfig().setTestPlay(getActivity());
                }
            }
        });

        if(BuildConfig.DEBUG && Logger.getShouldLog()) {
            radGrpVastProtocol.setVisibility(View.VISIBLE);
        } else {
            radGrpVastProtocol.setVisibility(View.GONE);
        }
        if(BuildConfig.DEBUG && Logger.getShouldLog()) {
            btnTestPlay.setVisibility(View.VISIBLE);
        } else {
            btnTestPlay.setVisibility(View.GONE);
        }
        if(BuildConfig.DEBUG && Logger.getShouldLog()) {
            btnCPIRule.setVisibility(View.VISIBLE);
            editCPIRule.setVisibility(View.VISIBLE);
        } else {
            btnCPIRule.setVisibility(View.GONE);
            editCPIRule.setVisibility(View.GONE);
        }
        Toolbar toolbar = (Toolbar) rootView.findViewById(R.id.pokkttoolbar);
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        radGrpVastProtocol.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                RadioButton radioButton=(RadioButton)group.findViewById(checkedId);
                String ver = radioButton.getText().toString();
                if(!TextUtils.isEmpty(ver)) {
                    if (ver.equalsIgnoreCase("vast4")) {
                        PokktConstants.URL_Ad_REQUEST_VAST_VERSION = "&protocols=7,8";
                    } else if (ver.equalsIgnoreCase("vast3")) {
                        PokktConstants.URL_Ad_REQUEST_VAST_VERSION = "&protocols=3,6";
                    } else if (ver.equalsIgnoreCase("vast2")) {
                        PokktConstants.URL_Ad_REQUEST_VAST_VERSION = "&protocols=2,5";
                    } else {
                        PokktConstants.URL_Ad_REQUEST_VAST_VERSION = "";
                    }
                }
            }
        });
        btnCPIRule.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String s = editCPIRule.getText().toString();
                try {
                    JSONObject o = new JSONObject(s);
                    PokktConstants.CPIRULE = editCPIRule.getText().toString();
                    Toast.makeText(getActivity().getApplicationContext(), "rule set", Toast.LENGTH_SHORT).show();
                } catch (Exception e) {
                    Toast.makeText(getActivity().getApplicationContext(), "Invalid data", Toast.LENGTH_SHORT).show();
                }
            }
        });
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        setFont(findView(view, R.id.txt_ad_settings));
        setFont(findView(view, R.id.btnAddExtraParams));
        setFont(findView(view, R.id.btnRemoveExtraParams));
        // setup data
        try {
            bindData();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private EditText[] addRow() {
        View child = inflater.inflate(R.layout.layout_extra_params_row, null);
        EditText edtKey = (EditText) child.findViewById(R.id.edtKey);
        EditText edtValue = (EditText) child.findViewById(R.id.edtValue);
        setFont(edtKey);
        setFont(edtValue);
        lnrLayoutExtraParamsContainer.addView(child);
        return new EditText[]{edtKey, edtValue};
    }

    private void setRowData(String key, String value) {

        EditText[] addedChildren = addRow();
        addedChildren[0].setText(key);
        addedChildren[1].setText(value);
    }

    private void bindData() throws Exception {

        Map<String, ?> map_extra_params = SharedPrefsUtil.getMapFromPref(getActivity().getApplicationContext(), PREF_EXTRA_PARAMS);
        if (map_extra_params.size() > 0) {
            for (Map.Entry<String, ?> pair : map_extra_params.entrySet()) {
                SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                        PREF_EXTRA_PARAMS, pair.getKey());
                setRowData(pair.getKey(), (String) pair.getValue());
            }
        }
    }

    private void resetData(){
        SharedPrefsUtil.clearSharedPref(getActivity().getApplicationContext(), PREF_EXTRA_PARAMS);
        lnrLayoutExtraParamsContainer.removeAllViews();
    }

    @Override
    public void onDestroy() {
        saveData();
        super.onDestroy();
    }

    private void saveData(){
        SharedPrefsUtil.clearSharedPref(getActivity().getApplicationContext(), PREF_EXTRA_PARAMS);

        for (int i = 0; i < lnrLayoutExtraParamsContainer.getChildCount(); i++) {

            View child = lnrLayoutExtraParamsContainer.getChildAt(i);
            EditText edtKey = (EditText) child.findViewById(R.id.edtKey);
            EditText edtValue = (EditText) child.findViewById(R.id.edtValue);

            if (!TextUtils.isEmpty(edtKey.getText().toString())) {
                SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(), PREF_EXTRA_PARAMS, edtKey.getText().toString(), edtValue.getText().toString());
            }
        }
    }
}
