package com.pokkt.demo.fragments;

import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.pokkt.PokktAds;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.PokktKotlinPluginKt;
import com.pokkt.demo.utility.Storage;


public class PokktInterstitialFragment extends BaseFragment implements PokktAds.Interstitial.InterstitialDelegate {

    // ui
    private TextView txtScreenName;
    private EditText edtScreenName;
    private ProgressBar progressCacheRewarded, progressShowRewarded, progressCacheNonRewarded, progressShowNonRewarded;
    private Button btnCacheRewarded, btnShowRewarded, btnCacheNonRewarded, btnShowNonRewarded;
    private TextView txtEarnedPoints;

    public PokktInterstitialFragment() {
        // Required empty public constructor
    }


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // getArguments here
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_pokkt_interstitial, container, false);

        // screen name
        txtScreenName = (TextView) findView(rootView,R.id.txt_screen_name);
        edtScreenName = (EditText) findView(rootView, R.id.edt_screen_name);
        edtScreenName.setContentDescription(getString(R.string.test_screenName));

        // earned points
        txtEarnedPoints = (TextView) findView(rootView, R.id.txt_earned_points);

        // cache rewarded
        progressCacheRewarded = (ProgressBar) findView(findView(rootView, R.id.btn_cache_rewarded), R.id.progressBar);
        btnCacheRewarded = (Button) findView(findView(rootView, R.id.btn_cache_rewarded), R.id.button);
        btnCacheRewarded.setContentDescription(getString(R.string.test_CacheRewardedIntBtn));

        // show rewarded
        progressShowRewarded = (ProgressBar) findView(findView(rootView, R.id.btn_show_rewarded), R.id.progressBar);
        btnShowRewarded = (Button) findView(findView(rootView, R.id.btn_show_rewarded), R.id.button);
        btnShowRewarded.setContentDescription(getString(R.string.test_ShowRewardedIntBtn));

        // cache non rewarded
        progressCacheNonRewarded = (ProgressBar) findView(findView(rootView, R.id.btn_cache_non_rewarded), R.id.progressBar);
        btnCacheNonRewarded = (Button) findView(findView(rootView, R.id.btn_cache_non_rewarded), R.id.button);
        btnCacheNonRewarded.setContentDescription(getString(R.string.test_CacheNonRewardedIntBtn));

        // show non rewarded
        progressShowNonRewarded = (ProgressBar) findView(findView(rootView, R.id.btn_show_non_rewarded), R.id.progressBar);
        btnShowNonRewarded = (Button) findView(findView(rootView, R.id.btn_show_non_rewarded), R.id.button);
        btnShowNonRewarded.setContentDescription(getString(R.string.test_ShowNonRewardedIntBtn));

        Toolbar toolbar = (Toolbar) rootView.findViewById(R.id.pokkttoolbar);
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        // setup data
        // screen name
        //setFont(edtScreenName);
        setFont(txtScreenName);

        // earned points
        setFont(txtEarnedPoints);
        txtEarnedPoints.setText(String.format(getString(R.string.txt_earned_points), String.valueOf(Storage.getVideoPoints(getActivity()))));

        // cache rewarded
        setFont(btnCacheRewarded);
        setProgressbarColor(progressCacheRewarded);
        btnCacheRewarded.setText(getString(R.string.txt_btn_cache_rewarded));
        btnCacheRewarded.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (isScreenNameSpecified()) {
                    String screenName = edtScreenName.getText().toString().trim();
                    if (Storage.isKotlin) {
                        if (!PokktKotlinPluginKt.isInterstitialAdCached(screenName, true)) {
                            progressCacheRewarded.setVisibility(View.VISIBLE);
                            PokktKotlinPluginKt.cacheRewardedInterstitial(screenName);
                        } else {
                            Toast.makeText(getActivity(), "Interstitial Ad already cached", Toast.LENGTH_SHORT).show();
                        }
                    } else {
                        if (!PokktAds.Interstitial.isAdCached(screenName, true)) {
                            progressCacheRewarded.setVisibility(View.VISIBLE);
                            if (isScreenNameSpecified()) {
                                PokktAds.Interstitial.cacheRewarded(screenName);
                            }
                        } else {
                            Toast.makeText(getActivity(), "Interstitial Ad already cached", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
            }
        });

        // show rewarded
        setFont(btnShowRewarded);
        setProgressbarColor(progressShowRewarded);
        btnShowRewarded.setText(getString(R.string.txt_btn_show_rewarded));
        btnShowRewarded.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                progressShowRewarded.setVisibility(View.VISIBLE);
                if (isScreenNameSpecified()) {
                    String screenName = edtScreenName.getText().toString().trim();
                    if(Storage.isKotlin) {
                        if (PokktKotlinPluginKt.isInterstitialAdCached(screenName, true)) {
                            Toast.makeText(getActivity(), "Interstitial Ad is cached, Showing", Toast.LENGTH_LONG).show();
                        }
                        PokktKotlinPluginKt.showRewardedInterstitial(screenName);

                    } else {
                        if (PokktAds.Interstitial.isAdCached(screenName, true)) {
                            Toast.makeText(getActivity(), "Interstitial Ad is cached, Showing", Toast.LENGTH_LONG).show();
                        }
                        PokktAds.Interstitial.showRewarded(screenName);
                    }
                }
            }
        });

        // cache non rewarded
        setFont(btnCacheNonRewarded);
        setProgressbarColor(progressCacheNonRewarded);
        btnCacheNonRewarded.setText(getString(R.string.txt_btn_cache_non_rewarded));
        btnCacheNonRewarded.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (isScreenNameSpecified()) {
                    String screenName = edtScreenName.getText().toString().trim();
                    if(Storage.isKotlin) {
                        if (!PokktKotlinPluginKt.isInterstitialAdCached(screenName, false)) {
                            progressCacheNonRewarded.setVisibility(View.VISIBLE);
                            if (isScreenNameSpecified()) {
                                PokktAds.Interstitial.cacheNonRewarded(screenName);
                            }
                        } else {
                            Toast.makeText(getActivity(), "Interstitial Ad already cached", Toast.LENGTH_SHORT).show();
                        }
                    } else {
                        if (!PokktAds.Interstitial.isAdCached(screenName, false)) {
                            progressCacheNonRewarded.setVisibility(View.VISIBLE);
                            if (isScreenNameSpecified()) {
                                PokktAds.Interstitial.cacheNonRewarded(screenName);
                            }
                        } else {
                            Toast.makeText(getActivity(), "Interstitial Ad already cached", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
            }
        });

        // show non rewarded
        setFont(btnShowNonRewarded);
        setProgressbarColor(progressShowNonRewarded);
        btnShowNonRewarded.setText(getString(R.string.txt_btn_show_non_rewarded));
        btnShowNonRewarded.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                progressShowNonRewarded.setVisibility(View.VISIBLE);
                if (isScreenNameSpecified()) {
                    String screenName = edtScreenName.getText().toString().trim();
                    if(Storage.isKotlin) {
                        if (PokktKotlinPluginKt.isInterstitialAdCached(screenName, false)) {
                            Toast.makeText(getActivity(), "Interstitial Ad is cached, Showing", Toast.LENGTH_LONG).show();
                        }
                        PokktKotlinPluginKt.showNonRewardedInterstitial(screenName);
                    } else {
                        if (PokktAds.Interstitial.isAdCached(screenName, false)) {
                            Toast.makeText(getActivity(), "Interstitial Ad is cached, Showing", Toast.LENGTH_LONG).show();
                        }
                        PokktAds.Interstitial.showNonRewarded(screenName);
                    }
                }
            }
        });

        // OPTIONAL but we SUGGEST you to implement callbacks as it will help you to determine the status of your request
        if(Storage.isKotlin) {
            PokktKotlinPluginKt.setDelegate(this);
        } else {
            PokktAds.Interstitial.setDelegate(this);
        }
    }

    private boolean isScreenNameSpecified() {
        if (TextUtils.isEmpty(edtScreenName.getText())) {
            Toast.makeText(getActivity(), "Please Enter Screen Name or Zone ID", Toast.LENGTH_LONG).show();
            hideProgress();
            return false;
        }
        return true;
    }

    private void hideProgress() {
        progressCacheRewarded.setVisibility(View.GONE);
        progressShowRewarded.setVisibility(View.GONE);
        progressCacheNonRewarded.setVisibility(View.GONE);
        progressShowNonRewarded.setVisibility(View.GONE);
    }

    // Interstitial Ad Callback

    @Override
    public void interstitialCachingCompleted(final String screenName, boolean isRewarded, final double reward) {
        if(getActivity() == null){
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Interstitial Ad Caching Completed ! Ad vc is: " + reward, Toast.LENGTH_LONG).show();
                if (edtScreenName.getText().toString().trim().equals(screenName)) { // screen name check as our SDK supports multiple ad-requests,
                    // it will help in identifying response to which request has arrived
                    hideProgress();
                }
            }
        });
    }

    @Override
    public void interstitialCachingFailed(final String screenName, boolean isRewarded, final String errorMessage) {
        if(getActivity() == null){
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Interstitial Ad Download Error " + errorMessage, Toast.LENGTH_LONG).show();
                if (edtScreenName.getText().toString().trim().equals(screenName)) {
                    hideProgress();
                }
            }
        });
    }

    @Override
    public void interstitialDisplayed(String screenName, boolean isRewarded) {
        if(getActivity() == null){
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                hideProgress();
                Toast.makeText(getActivity(), "Interstitial Ad Displayed", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void interstitialFailedToShow(final String screenName, boolean isRewarded, final String errorMessage) {
        if(getActivity() == null){
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Interstitial Ad Show Error " + errorMessage, Toast.LENGTH_LONG).show();
                if (edtScreenName.getText().toString().trim().equals(screenName)) {
                    hideProgress();
                }
            }
        });
    }

    @Override
    public void interstitialClosed(String screenName, boolean isRewarded) {
        if(getActivity() == null){
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                hideProgress();
                txtEarnedPoints.setText(String.format(getString(R.string.txt_earned_points), String.valueOf(Storage.getVideoPoints(getActivity()))));
                Toast.makeText(getActivity(), "Interstitial Ad Closed", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void interstitialSkipped(String screenName, boolean isRewarded) {//TODO - not getting called any where
        if(getActivity() == null){
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                hideProgress();
                Toast.makeText(getActivity(), "Interstitial Ad Skipped", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void interstitialCompleted(String screenName, boolean isRewarded) {
        if(getActivity() == null){
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                hideProgress();
                txtEarnedPoints.setText(String.format(getString(R.string.txt_earned_points), String.valueOf(Storage.getVideoPoints(getActivity()))));
                Toast.makeText(getActivity(), "Interstitial Ad Completed", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void interstitialGratified(String screenName, boolean isRewarded, final double reward) {
        if(getActivity() == null){
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                //hideProgress();
                Toast.makeText(getActivity(), "Points Earned " + reward, Toast.LENGTH_SHORT).show();
                Storage.storeVideoPoints(getActivity(), (float) reward);
                //txtEarnedPoints.setText(String.format(getString(R.string.txt_earned_points), String.valueOf(reward)));
            }
        });
    }

    @Override
    public void interstitialClicked(String screenName, boolean isRewarded) {
        if(getActivity() == null){
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Interstitial Ad Clicked", Toast.LENGTH_SHORT).show();
            }
        });
    }
}
