package com.pokkt.demo.fragments;

import android.graphics.Color;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

import com.pokkt.PokktAds;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.PokktKotlinPluginKt;
import com.pokkt.demo.utility.Storage;

import java.util.ArrayList;

public class PokktOutStreamListViewFragment extends BaseFragment implements PokktAds.OSAds.OSAdsDelegate{


    private ListView listView;

    public PokktOutStreamListViewFragment() {
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_pokkt_outstream_list_ad_type, container, false);

        ArrayList<String> content=  new ArrayList<String>();

        for(int i= 0; i<20; i++) {
            content.add("content : "+i);
        }
        listView = (ListView)rootView.findViewById(R.id.pokktoslist);
//        listView.setBackgroundColor(Color.WHITE);
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(getActivity(),android.R.layout.simple_list_item_1,android.R.id.text1,content);
        listView.setAdapter(adapter);
        listView.setContentDescription("test_listView");
        Toolbar toolbar = (Toolbar) rootView.findViewById(R.id.pokkttoolbar);
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        if(Storage.isKotlin) {
            PokktKotlinPluginKt.loadAdInContainer(getActivity(), listView, "default", 5, this); // step 1
        } else {
            PokktAds.OSAds.loadAdInContainer(getActivity(), listView, "default", 5, this); // step 1
        }
    }

    @Override
    public void adReady(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Ready ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adDisplayed(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Dispalyed ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adFailedToShow(String screenName, final String errorMessage) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Video Ad Show Error " + errorMessage, Toast.LENGTH_LONG).show();
            }
        });

    }

    @Override
    public void adCompleted(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Completed ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adSkipped(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Skipped ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adClicked(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Clicked ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        if(Storage.isKotlin) {
            PokktKotlinPluginKt.destroyAdInContainer("default");
        } else {
            PokktAds.OSAds.destroyAdInContainer("default");
        }
        PokktOutStreamFragment.isAllowClick = true;
    }
}
