package com.pokkt.demo.fragments;

import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.Toast;

import com.pokkt.PokktAds;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.PokktKotlinPluginKt;
import com.pokkt.demo.utility.Storage;

public class PokktOutStreamScrollFragment extends BaseFragment implements PokktAds.OSAds.OSAdsDelegate{


    private FrameLayout containerLayout;

    public PokktOutStreamScrollFragment() {
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_pokkt_outstream_scroll_ad_type, container, false);

        containerLayout = (FrameLayout)rootView.findViewById(R.id.placeholder);
        Toolbar toolbar = (Toolbar) rootView.findViewById(R.id.pokkttoolbar);
        rootView.findViewById(R.id.scrollView).setContentDescription("test_scrollView");
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        if(Storage.isKotlin) {
            PokktKotlinPluginKt.loadAdInContainer(getActivity(), containerLayout, "default", 0, this); // step 1
        } else {
            PokktAds.OSAds.loadAdInContainer(getActivity(), containerLayout, "default", 0, this); // step 1
        }
    }

    @Override
    public void adReady(String screenName) {
        containerLayout.setVisibility(View.VISIBLE);
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Ready ", Toast.LENGTH_SHORT).show();
            }
        });
        //one approach in xml android:layout_height="0dp" android:visibility="visible" and in java
        //containerLayout.setLayoutParams(new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, 300));
    }

    @Override
    public void adDisplayed(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad displayed ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adFailedToShow(String screenName, final String errorMessage) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Video Ad Show Error " + errorMessage, Toast.LENGTH_LONG).show();
                containerLayout.setVisibility(View.GONE);
            }
        });

    }

    @Override
    public void adCompleted(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Completed ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adSkipped(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Skipped ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adClicked(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Clicked ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        if(Storage.isKotlin) {
            PokktKotlinPluginKt.destroyAdInContainer("default");
        } else {
            PokktAds.OSAds.destroyAdInContainer("default");
        }
        PokktOutStreamFragment.isAllowClick = true;
    }
}
