package com.pokkt.demo.fragments;

import android.graphics.Color;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.RelativeLayout;
import android.widget.Toast;

import com.pokkt.PokktAds;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.PokktKotlinPluginKt;
import com.pokkt.demo.utility.Storage;

public class PokktOutStreamWebViewFragment extends BaseFragment implements PokktAds.OSAds.OSAdsDelegate{

    private final String screenName = "default";

    private WebView webView;
    private Button button;

    public PokktOutStreamWebViewFragment() {
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        View rootView = inflater.inflate(R.layout.fragment_pokkt_outstream_webview_ad_type, container, false);

        webView = (WebView)rootView.findViewById(R.id.pokktoswebview);
        webView.setContentDescription("test_webView");
        webView.setWebViewClient(new WebViewClient() {
            @Override
            public void onPageFinished(WebView view, String url) {
                super.onPageFinished(view, url);
                if(Storage.isKotlin) {
                    PokktKotlinPluginKt.initAgent(getActivity(), screenName); // step 2
                } else {
                    PokktAds.OSAds.initAgent(getActivity(), screenName); // step 2
                }
            }
        });
        webView.setWebChromeClient(new WebChromeClient() {
        });

        button = (Button)rootView.findViewById(R.id.pokktoswebbutton);
        button.setText("Show Ad");
        button.setEnabled(false);
        RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(300, 150);
        params.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM|RelativeLayout.CENTER_HORIZONTAL);
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                 webView.loadUrl("https://en.wikipedia.org/wiki/Jon_Snow_(character)");
 //               webView.loadUrl("https://s3-ap-southeast-1.amazonaws.com/pokktdocumentation/windows/test.html");
               //webView.loadUrl("file:///android_asset/demo.html");
                button.setEnabled(false);
            }
        });
        Toolbar toolbar = (Toolbar) rootView.findViewById(R.id.pokkttoolbar);
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        if(Storage.isKotlin) {
            PokktKotlinPluginKt.loadAdInContainer(getActivity(), webView, screenName, 0, this); // step 1
        } else {
            PokktAds.OSAds.loadAdInContainer(getActivity(), webView, screenName, 0, this); // step 1
        }
        //webView.loadUrl("file:///android_asset/demo.html");
//        webView.loadUrl("https://wiki.pokkt.com/Native_Android");
    }

    @Override
    public void adReady(String screenName) {
        button.setEnabled(true);
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Ready ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adDisplayed(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Dispalyed ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adFailedToShow(String screenName, final String errorMessage) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Video Ad Show Error " + errorMessage, Toast.LENGTH_LONG).show();
            }
        });

    }

    @Override
    public void adCompleted(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Completed ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adSkipped(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Skipped ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void adClicked(String screenName) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getActivity(), "Ad Clicked ", Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        if(Storage.isKotlin) {
            PokktKotlinPluginKt.destroyAdInContainer(screenName);
        } else {
            PokktAds.OSAds.destroyAdInContainer(screenName);
        }
        PokktOutStreamFragment.isAllowClick = true;
    }
}
