package com.pokkt.demo.fragments;

import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.pokkt.PokktAds;
import com.pokkt.ad.demo.BuildConfig;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.PokktKotlinPluginKt;
import com.pokkt.demo.utility.FragmentTransactionManager;
import com.pokkt.demo.utility.Storage;

public class PokktSettingsFragment extends BaseFragment {

    // ui
    // edt_security_key
    //btn_export_log btn_export_log_to_cloud
    private TextView txtIPAddress;
    private EditText edtIPAddress, edtApplicationID, edtSecurityKey, edtThirdPartyUserId;
    private Button btnPokktAdPlayerViewConfig, btnPokktUserDetails, btnExtraParams, btnExportLog, btnExportLogToCloud;


    public PokktSettingsFragment() {
        // Required empty public constructor
    }


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // getArguments here
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_settings, container, false);

        // ipAddress
        txtIPAddress = (TextView) findView(rootView, R.id.txt_ip_address);
        edtIPAddress = (EditText) findView(rootView, R.id.edt_ip_address);

        // application id
        edtApplicationID = (EditText) findView(rootView, R.id.edt_application_id);
        edtApplicationID.setContentDescription(getString(R.string.test_appId));

        // security key
        edtSecurityKey = (EditText) findView(rootView, R.id.edt_security_key);
        edtSecurityKey.setContentDescription(getString(R.string.test_secKey));

        edtThirdPartyUserId = (EditText) findView(rootView, R.id.edt_third_party_user_id);
        // ad player view config
        btnPokktAdPlayerViewConfig = (Button) findView(rootView, R.id.btn_pokkt_ad_player_view_config);
        //user details
        btnPokktUserDetails = (Button) findView(rootView, R.id.btn_pokkt_user_details);
        //extra params
        btnExtraParams = (Button) findView(rootView, R.id.btn_extra_params);

        // export log
        btnExportLog = (Button) findView(findView(rootView, R.id.btn_export_log), R.id.button);

        // export log to cloud
        btnExportLogToCloud = (Button) findView(findView(rootView, R.id.btn_export_log_to_cloud), R.id.button);
        Toolbar toolbar = (Toolbar) rootView.findViewById(R.id.pokkttoolbar);
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        // setup data

        // ipAddress
        if(getResources().getBoolean(R.bool.is_test_release)) {
            setFont(edtIPAddress);
            txtIPAddress.setVisibility(View.VISIBLE); // it is used for our testing purpose please igonre it
            edtIPAddress.setVisibility(View.VISIBLE);
        }

        // application id
        setFont(edtApplicationID);
        edtApplicationID.setText(Storage.getAppId(getActivity()));

        // security key
        setFont(edtSecurityKey);
        edtSecurityKey.setText(Storage.getSecurityKey(getActivity()));

        setFont(findView(view,R.id.txt_third_party_user_id ));
        setFont(findView(view,R.id.edt_third_party_user_id ));

        // ad player view config
        setFont(btnPokktAdPlayerViewConfig);
        btnPokktAdPlayerViewConfig.setText(getString(R.string.txt_pokkt_ad_player_view_config));
        btnPokktAdPlayerViewConfig.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                PokktAdPlayerViewConfigFragment fragment = new PokktAdPlayerViewConfigFragment();
                FragmentTransactionManager.addFragmentWithTag(getActivity(), R.id.container, fragment, PokktAdPlayerViewConfigFragment.class.getSimpleName());
            }
        });
        //user details
        setFont(btnPokktUserDetails);
        btnPokktUserDetails.setText(getString(R.string.txt_pokkt_user_details));
        btnPokktUserDetails.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                PokktUserDetailsFragment fragment = new PokktUserDetailsFragment();
                FragmentTransactionManager.addFragmentWithTag(getActivity(), R.id.container, fragment, PokktUserDetailsFragment.class.getSimpleName());
            }
        });
        //extra params
        setFont(btnExtraParams);
        btnExtraParams.setText(getString(R.string.txt_pokkt_extra_params));
        btnExtraParams.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                PokktExtraParamsFragment fragment = new PokktExtraParamsFragment();
                FragmentTransactionManager.addFragmentWithTag(getActivity(), R.id.container, fragment, PokktExtraParamsFragment.class.getSimpleName());
            }
        });

        // export log
        setFont(btnExportLog);
        btnExportLog.setText(getString(R.string.txt_export_log));
        btnExportLog.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(Storage.isKotlin) {
                    PokktKotlinPluginKt.exportLog(getActivity()); // if you want to export log to some specific location
                } else {
                    PokktAds.Debugging.exportLog(getActivity()); // if you want to export log to some specific location
                }
            }
        });

        // export log to cloud
        setFont(btnExportLogToCloud);
        btnExportLogToCloud.setText(getString(R.string.txt_export_to_cloud));
        btnExportLogToCloud.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(Storage.isKotlin) {
                    PokktKotlinPluginKt.exportLogToCloud(getActivity()); // if you want to export log to cloud
                } else {
                    PokktAds.Debugging.exportLogToCloud(getActivity()); // if you want to export log to cloud
                }
            }
        });

        //gdpr

        final CheckBox isKotlin = (CheckBox)findView(view,R.id.kotlin);
        if(BuildConfig.DEBUG) {

        }
        isKotlin.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                Storage.isKotlin = isKotlin.isChecked();
            }
        });
        final CheckBox gdprApplicable = (CheckBox)findView(view,R.id.gdprapplicable);
        final CheckBox gdprConsent = (CheckBox)findView(view,R.id.gdprconsent);
        Button gdprConsentButton = (Button) findView(view,R.id.btn_gdpr);
        gdprConsentButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PokktAds.ConsentInfo info = new PokktAds.ConsentInfo();
                info.setGDPRApplicable(gdprApplicable.isChecked());
                info.setGDPRConsentAvailable(gdprConsent.isChecked());
                if(Storage.isKotlin) {
                    PokktKotlinPluginKt.setDataAccessConsent(info);
                } else {
                    PokktAds.setDataAccessConsent(info);
                }
            }
        });


    }

    @Override
    public void onDestroy() {
        super.onDestroy();

        if (TextUtils.isEmpty(edtApplicationID.getText())) {
            Toast.makeText(getActivity(), "Please Enter Application Id", Toast.LENGTH_SHORT).show();
            return;
        }

        if (TextUtils.isEmpty(edtSecurityKey.getText())) {
            Toast.makeText(getActivity(), "Please Enter Security Key", Toast.LENGTH_SHORT).show();
            return;
        }

        // saving applicationID and SecurityKey for SDK locally
        String applicationId = edtApplicationID.getText().toString().trim();
        String securityKey = edtSecurityKey.getText().toString().trim();
        Storage.setAppId(getActivity(), applicationId);
        Storage.setSecurityKey(getActivity(), securityKey);

        // Updating PokktConfig in PokktSDk in case it is changed from this screen.
        if(Storage.isKotlin) {
            PokktKotlinPluginKt.setPokktConfig(applicationId, securityKey, getActivity());
        } else {
            PokktAds.setPokktConfig(applicationId, securityKey, getActivity());
        }
    }
}
